--[[
Name: Babble-Fish-2.2
Revision: $Rev: 24274 $
Authors(s): kagaro (sal.scotto@gmail.com)
Website: www.wowace.com
Documentation: http://www.wowace.com/wiki/Babble-Fish-2.2
SVN: http://svn.wowace.com/root/branch/Babble-2.2/Babble-Fish-2.2
Dependencies: AceLibrary, AceLocale-2.2
License: MIT
]]

local MAJOR_VERSION = "Babble-Fish-2.2"
local MINOR_VERSION = tonumber(string.sub("$Revision 23813$", 12, -3))

if not AceLibrary then error(MAJOR_VERSION .. " requires AceLibrary") end
if not AceLibrary:HasInstance("AceLocale-2.2") then error(MAJOR_VERSION .. " requires AceLocale-2.2") end

local _, x = AceLibrary("AceLocale-2.2"):GetLibraryVersion()
MINOR_VERSION = MINOR_VERSION * 100000 + x

if not AceLibrary:IsNewVersion(MAJOR_VERSION, MINOR_VERSION) then return end

local BabbleFish = AceLibrary("AceLocale-2.2"):new(MAJOR_VERSION)

BabbleFish:RegisterTranslations("enUS", function() return {
-- Fishing Node
	["Floating Wreckage"] = true,
	["Patch of Elemental Water"] = true,
	["Floating Debris"] = true,
	["Oil Spill"] = true,
	["Firefin Snapper School"] = true,
	["Greater Sagefish School"] = true,
	["Oily Blackmouth School"] = true,
	["Sagefish School"] = true,
	["School of Deviate Fish"] = true,
	["Stonescale Eel Swarm"] = true,
	["Muddy Churning Water"] = true,
	["Highland Mixed School"] = true,  
	["Pure Water"] = true,            
	["Bluefish School"] = true,
	["Feltail School"] = true, 
	["Mudfish School"] = true, 
	["School of Darter"] = true, 
	["Sporefish School"] = true,  
	["Steam Pump Flotsam"] = true, 
	["School of Tastyfish"] = true,
-- Quest Fish + Fished Loot for Quests
	["Sar'theris Striker"] = true,
	["Savage Coast Blue Sailfin"] = true,
	["Misty Reed Mahi Mahi"] = true,
	["Feralas Ahi"] = true,
	["Spotted Sunfish"] = true,
	["Lightning Eel"] = true,
	["Oil Covered Fish"] = true,
	["Plated Armorfish"] = true,
	["Darkshore Grouper"] = true,
	["Electropeller"] = true,
	["Gaffer Jack"] = true,
	["Speckled Tastyfish"] = true,
	["Keefer's Angelfish"] = true,
	["Dezian Queenfish"] = true,
	["Brownell's Blue Striped Racer"] = true,
-- Normal Fish
	["Stonescale Eel"] = true,
	["Oily Blackmouth"] = true,
	["Firefin Snapper"] = true,
	["Oil Covered Fish"] = true,
	["Sickly Looking Fish"] = true,
	["Raw Brilliant Smallfish"] = true,
	["Raw Bristle Whisker Catfish"] = true,
	["Raw Glossy Mightfish"] = true,
	["Raw Greater Sagefish"] = true,
	["Raw Loch Frenzy"] = true,
	["Raw Longjaw Mud Snapper"] = true,
	["Raw Mithril Head Trout"] = true,
	["Raw Nightfin Snapper"] = true,
	["Raw Rainbow Fin Albacore"] = true,
	["Raw Redgill"] = true,
	["Raw Rockscale Cod"] = true,
	["Raw Sagefish"] = true,
	["Raw Slitherskin Mackerel"] = true,
	["Raw Spotted Yellowtail"] = true,
	["Raw Summer Bass"] = true,
	["Raw Sunscale Salmon"] = true,
	["Raw Whitescale Salmon"] = true,
	["Darkclaw Lobster"] = true,
	["Deviate Fish"] = true,
	["Large Raw Mightfish"] = true,
	["Winter Squid"] = true,
	["Felblood Snapper"] = true,
	["Figluster's Mudfish"] = true,
	["Furious Crawdad"] = true,
	["Golden Darter"] = true,
	["Icefin Bluefish"] = true,
	["Spotted Feltail"] = true,
	["Zangarian Sporefish"] = true,
	["Goldenscale Vendorfish"] = true,
}
end)

local fishingSkill = {
	["Stonescale Eel"] = 205,
	["Oily Blackmouth"] = 55,
	["Firefin Snapper"] = 55,
	["Oil Covered Fish"] = 20,
	["Sickly Looking Fish"] = 1,
	["Raw Brilliant Smallfish"] = 1,
	["Raw Bristle Whisker Catfish"] = 130,
	["Raw Glossy Mightfish"] = 205,
	["Raw Greater Sagefish"] = 205,
	["Raw Loch Frenzy"] = 20,
	["Raw Longjaw Mud Snapper"] = 1,
	["Raw Mithril Head Trout"] = 55,
	["Raw Nightfin Snapper"] = 205,
	["Raw Rainbow Fin Albacore"] = 55,
	["Raw Redgill"] = 205,
	["Raw Rockscale Cod"] = 205,
	["Raw Sagefish"] = 205,
	["Raw Slitherskin Mackerel"] = 20,
	["Raw Spotted Yellowtail"] = 205,
	["Raw Summer Bass"] = 205,
	["Raw Sunscale Salmon"] = 205,
	["Raw Whitescale Salmon"] = 330,
	["Darkclaw Lobster"] = 330,
	["Deviate Fish"] = 55,
	["Large Raw Mightfish"] = 330,
	["Winter Squid"] = 205,
	["Felblood Snapper"] = 290,
	["Figluster's Mudfish"] = 380,
	["Furious Crawdad"] = 430,
	["Golden Darter"] = 430,
	["Icefin Bluefish"] = 380,
	["Spotted Feltail"] = 355,
	["Zangarian Sporefish"] = 305
}
local fishingNode = {
	["Floating Wreckage"] = 130,
	["Patch of Elemental Water"] = 330,
	["Floating Debris"] = 130,
	["Oil Spill"] = 20,
	["Firefin Snapper School"] = 55,
	["Greater Sagefish School"] = 130,
	["Oily Blackmouth School"] = 55,
	["Sagefish School"] = 130,
	["School of Deviate Fish"] = 55,
	["Stonescale Eel Swarm"] = 205,
	["Muddy Churning Water"] = 330,
	["Highland Mixed School"] = 430,  
	["Pure Water"] = 430,            
	["Bluefish School"] = 380,
	["Feltail School"] = 355, 
	["Mudfish School"] = 380, 
	["School of Darter"] = 430, 
	["Sporefish School"] = 305,  
	["Steam Pump Flotsam"] = 305, 
	["School of Tastyfish"] = 130,
}
local questFish = {
	["Sar'theris Striker"] = true,
	["Savage Coast Blue Sailfin"] = true,
	["Misty Reed Mahi Mahi"] = true,
	["Feralas Ahi"] = true,
	["Spotted Sunfish"] = true,
	["Lightning Eel"] = true,
	["Oil Covered Fish"] = true,
	["Plated Armorfish"] = true,
	["Darkshore Grouper"] = true,
	["Electropeller"] = true,
	["Gaffer Jack"] = true,
	["Speckled Tastyfish"] = true,
	["Keefer's Angelfish"] = true,
	["Dezian Queenfish"] = true,
	["Brownell's Blue Striped Racer"] = true,
}

BabbleFish:Debug()
BabbleFish:SetStrictness(true)

-- NOTE for mod authors:
-- The minimum fishing skill represents the MINIMUM they need to fish one these fish or items, however skill needed for any
-- given spot in teh game is determined by Zone and SubZone.  Babble-Zone has the skill per zone it in.
function BabbleFish:GetMinSkill(fish)
	self:argCheck(fish, 2, "string")
	local skill = fishingSkill[fish] or fishingSkill[self:HasReverseTranslation(fish) and self:GetReverseTranslation(fish) or false]
	if not skill then
		return nil
	end
	return skill,375
end

function BabbleFish:GetMinSkillForNode(node)
	self:argCheck(node, 2, "string")
	local skill = fishingNode[node] or fishingNode[self:HasReverseTranslation(node) and self:GetReverseTranslation(node) or false]
	if not skill then
		return nil
	end
	return skill
end

-- Is the item a fishing node?
function BabbleFish:IsFishingNode(node)
	self:argCheck(node, 2, "string")
	local skill = fishingNode[node] or fishingNode[self:HasReverseTranslation(node) and self:GetReverseTranslation(node) or false]
	return skill and true
end

-- is the item a fish?
function BabbleFish:IsFish(fish)
	self:argCheck(fish, 2, "string")
	local skill = fishingSkill[fish] or fishingSkill[self:HasReverseTranslation(fish) and self:GetReverseTranslation(fish) or false]
	return skill and true
end

-- is the item a quest fish?
function BabbleFish:IsQuestFish(fish)
	self:argCheck(fish, 2, "string")
	local skill = questFish[fish] or questFish[self:HasReverseTranslation(fish) and self:GetReverseTranslation(fish) or false]
	return skill and true
end

AceLibrary:Register(BabbleFish, MAJOR_VERSION, MINOR_VERSION)
BabbleFish = nil